import es, playerlib, spe, random, gamethread, popuplib, weaponlib, keyfile, pickle

BOMB_PLANTED = 0
HOSTAGE_GRABBED = 0

KILL_GOLD = list(range(1,11))
KNIFE_GOLD = list(range(11,41))
GRENADE_GOLD = list(range(11,41))
BOMB_GOLD = list(range(51,61))
DEFUSE_GOLD = list(range(51,61))
HOSTAGE_GOLD = list(range(61,71))

def load():
    es.regcmd('postxp', 'dndpython/postxp', 'Bonus XP for posting in the forums')
    es.regcmd('tell', 'dndpython/tell', 'Sends a message to a player')
    es.regcmd('gold', 'dndpython/gold', 'Gives gold for kills')
    es.regcmd('pythonfireball', 'dndpython/pythonfireball', 'Responsible for !fire aoe damage')
    es.regcmd('teamhealth', 'dndpython/teamhealth', 'Changes entire teams health')
    es.regcmd('aoeregen', 'dndpython/aoeregen', 'Regenerates health in AOE')
    es.regcmd('clericresmenu', 'dndpython/clericresmenu', 'Revives players')
    es.regcmd('pythonblind', 'dndpython/pythonblind', 'Blinds enemy team')
    es.regcmd('pythonunblind', 'dndpython/pythonunblind', 'Unblinds ally team')
    es.regcmd('pythonhellfire', 'dndpython/pythonhellfire', 'AOE Fire')
    es.regcmd('zombieghoul', 'dndpython/zombieghoul', 'Necro revive ability')
    es.regcmd('rebukeaoe', 'dndpython/rebukeaoe', 'Necro boost undead ability')
    es.regcmd('bardboost', 'dndpython/bardboost', 'Bard Boost')
    es.regcmd('bardcharge', 'dndpython/bardcharge', 'Bard Charge')
    es.regcmd('bardgrav', 'dndpython/bardgrav', 'Bard Anti-grav')
    es.regcmd('bardshock', 'dndpython/bardshock', 'Bard Shock')
    es.regcmd('pythonmeteor', 'dndpython/pythonmeteor', 'Arcane Order Meteor')
    es.regcmd('massinvis', 'dndpython/mass', 'Wizard mass invisibilty spell')
    es.regcmd('teamheal', 'dndpython/teamheal', 'Cleric team heal')
    es.regcmd('pythonhurtundead', 'dndpython/pythonhurtundead', 'Cleric turn')
    
    watercheck()
    
def unload():
    gamethread.cancelDelayed('watercheck')
    
weaponRest = {
'shotguns':['m3', 'xm1014'],
'grenades':['hegrenade', 'flashbang', 'smokegrenade'],
'Fighter':['awp', 'g3sg1', 'sg550'],
'Rogue':['galil', 'famas', 'p90', 'm4a1', 'ak47', 'awp', 'g3sg1', 'sg550', 'aug', 'sg552', 'm249'],
'Wizard':['glock', 'usp', 'fiveseven', 'elite', 'p228'],
'Cleric':['scout', 'm4a1', 'ak47', 'sg552', 'aug', 'awp', 'g3sg1', 'sg550'],
'Bard':['m4a1', 'ak47', 'sg552', 'aug', 'awp', 'g3sg1', 'sg550', 'm249'],
'Ranger':['scout', 'elite'],
'Necromancer':['glock', 'usp', 'p228', 'fiveseven', 'elite'],
'elf':['m4a1', 'ak47', 'scout'],
'greyelf':['p90', 'ump'],
'aasimar':['ump'],
'tiefling':['mp5navy'],
'avariel':['scout'],
'minotaur':['m249'],
'troll':['glock', 'usp', 'fiveseven', 'elite', 'p228', 'deagle'],
'tibbit':['usp'],
'filcher':['knife'],
'golem':['knife'],
'basilisk':['knife'],
'rabbit':['knife'],
'rok':['scout'],
'chaindevil':['glock', 'usp', 'fiveseven', 'elite', 'p228'],
'zombie':['knife'],
'ghoul':['knife']
}


weaponRest['Wizard'].append('knife')
weaponRest['Ranger'].append('knife')
weaponRest['Necromancer'].append('knife')
weaponRest['troll'].append('knife')
weaponRest['tibbit'].append('knife')
weaponRest['chaindevil'].append('knife')
weaponRest['rok'].append('knife')
for v in weaponRest['grenades']:
    weaponRest['Wizard'].append(v)
    weaponRest['Ranger'].append(v)
    weaponRest['Necromancer'].append(v)
    weaponRest['troll'].append(v)
    weaponRest['tibbit'].append(v)
    weaponRest['chaindevil'].append(v)
        
def item_pickup(ev):
    if ev['item'] not in ['item_defuser', 'item_kevlar', 'item_assaultsuit', 'item_nvgs', 'c4', 'weapon_c4']:
        userid = ev['userid']
        steam = es.getplayersteamid(userid)
        race = str(es.keygetvalue('dndUsers', steam, 'race')).lower()
        dndClass = es.keygetvalue('dndUsers', steam, 'class')
        prestige = str(es.keygetvalue('dndUsers', steam, 'prestige'))
        
        if prestige == '':
            prestige = 'none'
        
        if ev['item'] in weaponRest['shotguns']:
            spe.dropWeapon(userid, 'weapon_' + ev['item'], 1)
            es.tell(userid, '#multi', '#green[D&D] #defaultShotguns are disabled for this mod!')
        
        
        if prestige.lower() != 'rpc3' and race not in ['filcher', 'rabbit']:
            color = es.keygetvalue('dndExtra', steam, 'color')
            allow = es.keygetvalue('dndExtra', steam, 'allow_color')
            if allow:
                es.server.queuecmd('es est_setplayercolor %s 255 255 255 %s 1'%(userid, color))
        else:
            playerlib.getPlayer(userid).setColor(255, 255, 255, 0)
            
        if prestige.lower() == 'rpc3':
            if ev['item'] != 'knife':
                spe.dropWeapon(userid, 'weapon_' + ev['item'], 1)
                es.tell(userid, '#multi', '#green[D&D] #defaultYour race is not allowed to use weapons!')
        
        if race == 'giant':
            for weapon in spe.getWeaponNameList(userid):
                spe.dropWeapon(userid, weapon, 1)
                es.tell(userid, '#multi', '#green[D&D] #defaultYour race is not allowed to use weapons!')
            return
        
        if race in ['troll', 'chaindevil', 'rok', 'filcher', 'golem', 'basilisk', 'rabbit', 'rok', 'zombie', 'ghoul']:
            if ev['item'] not in weaponRest[race]:
                spe.dropWeapon(userid, 'weapon_' + ev['item'], 1)
                es.tell(userid, '#multi', '#green[D&D] #defaultYour race is not allowed to use that weapon!')
                return
                
        if dndClass in ['Fighter', 'Rogue', 'Cleric', 'Bard']:
            if ev['item'] in weaponRest[dndClass]:
                remove = 1
                if race in ['elf', 'greyelf', 'avariel', 'minotaur', 'aasimar', 'tiefling'] and ev['item'] in weaponRest[race]:
                    remove = 0
                if prestige.lower() == 'cpc1':
                    if ev['item'] in ['m4a1', 'p90', 'ak47']:
                        level = 0
                        try:
                            level = int(es.keygetvalue('dndUsers', steam, prestige))
                        except:
                            remove = 1
                        if level:
                            try:
                                level -= int(es.keygetvalue('dndUsers', steam, 'la'))
                            except:
                                level = level
                            if level >= 1 and ev['item'] == 'p90':
                                remove = 0
                            if level >= 5 and ev['item'] in ['m4a1', 'ak47']:
                                remove = 0
                if ev['item'] == 'awp':
                    if dndClass == 'Fighter':
                        try:
                            awp = int(es.keygetvalue('dndExtra', steam, 'awp'))
                            remove = 0
                        except:
                            remove = 1
                if ev['item'] in ['g3sg1', 'sg550']:
                    if prestige.lower() == 'fpc3':
                        try:
                            if int(es.keygetvalue('dndUsers', steam, 'fpc3')):
                                remove = 0
                        except:
                            remove = 1
                if remove:
                    spe.dropWeapon(userid, 'weapon_' + ev['item'], 1)
                    es.tell(userid, '#multi', '#green[D&D] #defaultYour class is not allowed to use that weapon!')
                return
                    
        if dndClass in ['Wizard', 'Necromancer']:
            if ev['item'] not in weaponRest[dndClass]:
                remove = 1
                if race in ['elf', 'greyelf', 'avariel', 'minotaur', 'aasimar', 'tiefling'] and ev['item'] in weaponRest[race]:
                    remove = 0
                if remove:
                    spe.dropWeapon(userid, 'weapon_' + ev['item'], 1)
                    es.tell(userid, '#multi', '#green[D&D] #defaultYour class is not allowed to use that weapon!')
                return
        
        if dndClass.lower() == 'monk':
            if ev['item'] != 'knife':
                spe.dropWeapon(userid, 'weapon_' + ev['item'], 1)
                es.tell(userid, '#multi', '#green[D&D] #defaultYour class is not allowed to use that weapon!')
                return
                    
        if dndClass == 'Ranger':
            if ev['item'] not in weaponRest['Ranger']:
                spe.dropWeapon(userid, 'weapon_' + ev['item'], 1)
                es.tell(userid, '#multi', '#green[D&D] #defaultYour class is not allowed to use that weapon!')
            if es.keygetvalue('dndExtra', steam, 'style') == '':
                es.keysetvalue('dndExtra', steam, 'style', 'dual')
                es.tell(userid, '#multi', '#green[D&D] #defaultNo weapon type choosen.... defaulting to dual')
            if es.keygetvalue('dndExtra', steam, 'style') == 'archer':
                if ev['item'] == 'elite':
                    spe.dropWeapon(userid, 'weapon_' + ev['item'], 1)
                    es.tell(userid, '#multi', '#green[D&D] #defaultYour style is ranged!')
            if es.keygetvalue('dndExtra', steam, 'style') == 'dual':
                if ev['item'] == 'scout':
                    spe.dropWeapon(userid, 'weapon_' + ev['item'], 1)
                    es.tell(userid, '#multi', '#green[D&D] #defaultYour style is dual-weilding!')
            return
    
        if race == 'tibbit':
            mode = es.keygetvalue('dndExtra', steam, 'cat')
            if int(mode):
                weapons = spe.getWeaponNameList(userid)
                for weapon in weapons:
                    if weapon not in ['knife', 'weapon_knife']:
                        spe.dropWeapon(userid, weapon, 1)
                        spe.dropWeapon(userid, 'weapon_usp', 1)
            else:                
                weapons = spe.getWeaponNameList(userid)
                for weapon in weapons:
                    if weapon not in ['knife', 'weapon_knife', 'weapon_usp', 'weapon_hegrenade', 'weapon_smokegrenade', 'weapon_flashbang', 'weapon_hegrenade']:
                        spe.dropWeapon(userid, weapon, 1)
            return
            
def bonusxp():
    xp = 10
    userid = es.getargv(1)
    if int(es.getargc()) > 1:
        xp = int(es.getargv(2))
    if userid in es.getUseridList():
        curxp = 0
        try:
            curxp = es.keygetvalue('dndUsers', es.getplayersteamid(userid), 'curxp')
            cxp = int(es.keygetvalue('dndUsers', es.getplayersteamid(userid), curxp))
        except:
            cxp = 0
        es.keysetvalue('dndUsers', es.getplayersteamid(userid), curxp, cxp+xp)
        es.tell(userid, '#green', 'You have gained %sxp for being an active part of the community!'%xp)
    else:
        es.msg('That user could not be found')
        
def tell():
    count = es.getargc()
    userid = es.getargv(1)
    msg = ''
    for x in range(2,count+1):
        if es.getargv(x) == '#multi':
            pass
        else:
            if x > 2:
                msg += ' '
            msg += es.getargv(x)
    es.tell(userid, '#multi', '#green[D&D] #default' + msg)
        
                        
def round_end(ev):
    for userid in es.getUseridList():
        es.server.queuecmd('resethealth %s'%userid)
        if int(es.getplayerteam(userid)) == int(ev['winner']):
            es.server.queuecmd('es win_xp %s'%userid)
            
    client_data = keyfile.Parse(es.getAddonPath('dnd') + '/es_dndusers_db.txt')
    client_data = client_data['dndUsers']

    str_path = open(es.getAddonPath('dnd') + '/playerdict.txt', 'wb')
    pickle.dump(client_data, str_path)
    str_path.close()
        
def teamhealth():
    team = int(es.getargv(1))
    health = int(es.getargv(2))
    for userid in es.getUseridList():
        if int(es.getplayerteam(userid)) == team:
            if es.getplayersteamid(userid) != 'BOT':
                maxhealth = int(es.keygetvalue('dndExtra', es.getplayersteamid(userid), 'maxhealth')) + health
                es.keysetvalue('dndExtra', es.getplayersteamid(userid), 'maxhealth', maxhealth)
                es.setplayerprop(userid, 'CBasePlayer.m_iHealth', maxhealth)
            
def aoeregen(userid=None,delay=None, amount=None, distance=None):
    if userid == None:
        userid = es.getargv(1)
    if delay == None:
        delay = es.getargv(2)
    if amount == None:    
        amount = int(es.getargv(3))
    if distance == None:
        distance = int(es.getargv(4))
    
    
    if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
        
        playerlist = playerlib.getPlayer(userid).getNearPlayers(distance)
        playerlist.append(userid)
        for player in playerlist:
            if not int(es.getplayerprop(player, 'CBasePlayer.pl.deadflag')):
                curhealth = int(es.getplayerprop(player, 'CBasePlayer.m_iHealth'))
                if curhealth + amount > int(es.keygetvalue('dndExtra', es.getplayersteamid(player), 'maxhealth')):
                    es.setplayerprop(player, 'CBasePlayer.m_iHealth', int(es.keygetvalue('dndExtra', es.getplayersteamid(player), 'maxhealth')))
                else:
                    es.setplayerprop(player, 'CBasePlayer.m_iHealth', curhealth + amount)
        gamethread.delayedname(int(delay), 'aoeheal', aoeregen, args=(userid, delay, amount, distance))
            
        
''' es pythonfireball server_var(es_userid) server_var(point) server_var(wrandom) server_var(random) server_var(level) '''
def pythonfireball():
    caster = es.getargv(1)
    target = es.getargv(2)
    dc = int(es.getargv(3))
    damage = int(es.getargv(4))
    burn_bardTime = es.getargv(5)
    
    #es.msg('caster %s target %s dc %s damage %s burn_bardTime %s'%(caster, target, dc, damage, burn_bardTime))
    
    victims = playerlib.getPlayer(target).getNearPlayers(240)
    victims.append(target)
    for userid in victims:
        #es.msg(userid)
        
        myPlayer = playerlib.getPlayer(userid)    
        if myPlayer.isdead:
            pass
        
        save = random.randint(1,21)
        if save < 20:
        
            save += int(float(es.keygetvalue('dndExtra', es.getplayersteamid(userid), 'reflexsave')))
            
            if es.keygetvalue('dndUsers', es.getplayersteamid(userid), 'race').lower() == 'troll':
                damage = damage * 2
            
            if save < dc:
                damage = damage / 2
                es.tell(caster, '#multi', '#green[D&D] #defaultYour victim has taken %s from your fire ball!'%damage)
                es.tell(userid, '#multi', '#green[D&D] #defaultYou just took half damage from a fire ball!!')
                es.server.queuecmd('point_hurt %s %s %s'%(caster, userid, damage))
                
            else:
                es.tell(caster, '#multi', '#green[D&D] #defaultYou have used fire ball dealing %s damage! Watch them burn!'%damage)
                es.tell(userid, '#multi', '#green[D&D] #defaultYou have just been hit by a fireball and are now burning!!!!')
                es.server.queuecmd('point_hurt %s %s %s'%(caster, userid, damage))
                es.server.queuecmd('est_burn %s %s'%(userid, burn_bardTime)) 

def watercheck():                
    for userid in es.getUseridList():
        if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
            steam = es.getplayersteamid(userid)
            if es.keygetvalue('dndUsers', steam, 'race') == 'WaterEle':
                state = es.getplayerprop(userid, 'CBasePlayer.localdata.m_nWaterLevel')
                water = int(es.keygetvalue('dndExtra', steam, 'water'))
                health = int(es.keygetvalue('dndExtra', steam, 'maxhealth'))
                if state == 0:
                    if water > state:
                        es.tell(userid, '#multi', '#green[D&D] #defaultYou have lost health for leaving your element')
                        es.keysetvalue('dndExtra', steam, 'water', 0)
                        es.keysetvalue('dndExtra', steam, 'maxhealth', health - 25)
                        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth')) - 25)
                if state == 1:
                    if water > state:
                        es.tell(userid, '#multi', '#green[D&D] #defaultYou have lost health for leaving your element')
                        es.keysetvalue('dndExtra', steam, 'water', 0)
                        es.keysetvalue('dndExtra', steam, 'maxhealth', health - 25)
                        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth')) - 25)
                    if water < state:
                        es.tell(userid, '#multi', '#green[D&D] #defaultYou have gained health for entering your element')
                        es.keysetvalue('dndExtra', steam, 'water', 1)
                        es.keysetvalue('dndExtra', steam, 'maxhealth', health + 25)
                        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth')) + 25)
                if state == 2:
                    if water > state:
                        es.tell(userid, '#multi', '#green[D&D] #defaultYou have lost health for leaving your element')
                        es.keysetvalue('dndExtra', steam, 'water', 0)
                        es.keysetvalue('dndExtra', steam, 'maxhealth', health - 25)
                        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth')) - 25)
                    if water < state:
                        es.tell(userid, '#multi', '#green[D&D] #defaultYou have gained health for entering your element')
                        es.keysetvalue('dndExtra', steam, 'water', 2)
                        es.keysetvalue('dndExtra', steam, 'maxhealth', health + 25)
                        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth')) + 25)
                if state == 3:
                    if water > state:
                        es.tell(userid, '#multi', '#green[D&D] #defaultYou have lost health for leaving your element')
                        es.keysetvalue('dndExtra', steam, 'water', 0)
                        es.keysetvalue('dndExtra', steam, 'maxhealth', health - 50)
                        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth')) - 50)
                    if water < state:
                        es.tell(userid, '#multi', '#green[D&D] #defaultYou have gained health for entering your element')
                        es.keysetvalue('dndExtra', steam, 'water', 3)
                        es.keysetvalue('dndExtra', steam, 'maxhealth', health + 50)
                        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth')) + 50)
    gamethread.delayedname(1, 'watercheck', watercheck)
    
def mass():
    userid = es.getargv(1)
    for player in es.getUseridList():
        if es.getplayerteam(player) == es.getplayerteam(userid) and not es.getplayerprop(player, 'CBasePlayer.pl.deadflag'):
            if es.keygetvalue('dndUsers', es.getplayersteamid(player), 'prestige') != 'rpc3':
                if es.keygetvalue('dndUsers', es.getplayersteamid(player), 'race') != 'filcher':
                    es.keysetvalue('dndExtra', es.getplayersteamid(player), 'invis_bardTimer', 1)
                    color = min(es.keygetvalue('dndExtra', es.getplayersteamid(player), 'color'), 255)
                    es.server.queuecmd('est_setplayercolor %s 255 255 255 0'%player)
                    es.tell(player, '#multi', '#green[D&D] #defaultYour team is invisible for the next 3 seconds.')
                    gamethread.delayed(3, unvis, args=(player, color))
            
def unvis(userid, color):
    es.keysetvalue('dndExtra', es.getplayersteamid(userid), 'invis_bardTimer', 0)
    es.server.queuecmd('est_setplayercolor %s 255 255 255 %s 1'%(userid, color))
    es.tell(userid, '#multi', '#green[D&D] #defaultYou are visible again.')
    
def clericresmenu():
    resmenu = popuplib.easymenu('clericresmenu_%s'%es.getargv(1), None, reschoice)
    resmenu.settitle('Choose a dead teamate to raise from the dead:')
    for userid in es.getUseridList():
        if playerlib.getPlayer(userid).isdead:
            if es.getplayerteam(userid) == es.getplayerteam(es.getargv(1)):
                resmenu.addoption(userid, es.getplayername(userid))
    es.server.queuecmd('mcudnd %s'%es.getargv(1))
    gamethread.delayed(.2, resmenu.send, es.getargv(1))
    
def reschoice(userid, choice, popupname):
    playerchoice = popuplib.easymenu('reschoice_%s'%choice, None, reschoice2)
    playerchoice.settitle('Do you want to be resurrected by a Cleric?')
    playerchoice.addoption(1, 'Yes')
    playerchoice.addoption(2, 'No')
    es.server.queuecmd('mcudnd %s'%choice)
    gamethread.delayed(.2, playerchoice.send, choice)
    if es.getplayersteamid(choice) == 'BOT':
        gamethread.delayed(.3, es.server.queuecmd, args=('ma_cexec %s 1'%choice))
    es.keysetvalue('dndExtra', es.getplayersteamid(choice), 'reser', userid)
    
def reschoice2(userid, choice, popupname):
    cleric = es.keygetvalue('dndExtra', es.getplayersteamid(userid), 'reser')
    if choice == 1:
        try:
            rescount = int(es.keygetvalue('dndExtra', es.getplayersteamid(userid), 'res_count'))
        except:
            rescount = 0
        if not playerlib.getPlayer(cleric).isdead:
            if playerlib.getPlayer(userid).isdead:
                if es.keygetvalue('dndExtra', es.getplayersteamid(userid), 'zombie') == '1':
                    es.tell(cleric, '#multi', '#green[D&D] #default%s is undead and can not be rezzed'%es.getplayername(userid))
                else:
                    if es.keygetvalue('dndExtra', es.getplayersteamid(userid), 'ghoul') == '1':
                        es.tell(cleric, '#multi', '#green[D&D] #default%s is undead and can not be rezzed'%es.getplayername(userid))
                    else:
                        mana = int(es.keygetvalue('dndExtra', es.getplayersteamid(cleric), 'mana'))
                        if mana >= 35:
                            if rescount < 5:
                                rescount += 1
                                es.keysetvalue('dndExtra', es.getplayersteamid(userid), 'res_count', rescount)
                                es.keysetvalue('dndExtra', es.getplayersteamid(cleric), 'mana', mana-35)                            
                                x = es.keygetvalue('dndExtra', es.getplayersteamid(userid), 'd_x')
                                y = es.keygetvalue('dndExtra', es.getplayersteamid(userid), 'd_y')
                                z = es.keygetvalue('dndExtra', es.getplayersteamid(userid), 'd_z')
                                es.server.cmd('est_spawn %s'%userid)
                                es.server.cmd('ma_teleport %s %s %s %s'%(userid, x, y, z))
                                es.tell(userid, '#multi', '#green[D&D] #defaultYou have been restored to life by %s'%es.getplayername(cleric))
                                es.tell(cleric, '#multi', '#green[D&D] #defaultYou have brought %s back to life!'%es.getplayername(userid))
                            else:
                                es.tell(cleric, '#multi', '#green[D&D] #default%s has been restored to life too many bardTimes this round'%es.getplayername(userid))
                        else:
                            es.tell(cleric, '#multi', '#green[D&D] #defaultYou do not have enough mana to cast that spell!')
            else:
                es.tell(cleric, '#multi', '#green[D&D] #default%s is already alive and can not be rezzed'%es.getplayername(userid))
    else:
        es.tell(cleric, '#multi', '#green[D&D] #default%s does not wish to come back from the dead'%es.getplayername(userid))
        
def pythonblind():
    caster = es.getargv(1)
    for userid in es.getUseridList():
        if not playerlib.getPlayer(userid).isdead and es.getplayerteam(userid) != es.getplayerteam(caster):
            es.server.queuecmd('est_Fade %s 3 0 1 0 0 0 225'%userid)
            es.tell(userid, '#multi', '#green[D&D] #default%s blinded you with bane!'%es.getplayername(caster))
            
def pythonunblind():
    caster = es.getargv(1)
    for userid in es.getUseridList():
        if es.getplayerteam(userid) == es.getplayerteam(caster):
            es.server.queuecmd('est_Fade %s 3 0 1 0 0 0 0'%userid)
            es.tell(userid, '#multi', '#green[D&D] #default%s unblinded you with purge!'%es.getplayername(caster))
            
def pythonhellfire():
    caster = es.getargv(1)
    victims = playerlib.getPlayer(caster).getNearPlayers(480)
    for userid in victims:
        if not playerlib.getPlayer(userid).isdead:
            save = random.randint(1,21)
            if save < 20:
                try:
                    save += int(float(es.keygetvalue('dndExtra', es.getplayersteamid(userid), 'reflexsave')))
                except:
                    save = save
                    
                level = int(es.keygetvalue('dndUsers', es.getplayersteamid(caster), 'Necromancer'))
                try:
                    level += int(es.keygetvalue('dndUsers', es.getplayersteamid(caster), 'la'))
                except:
                    level = level
                damage = min(10, 5 * level)
                if es.keygetvalue('dndUsers', es.getplayersteamid(userid), 'race') == 'troll':
                    damage = damage * 2
                if save < 15:
                    es.server.queuecmd('point_hurt %s %s %s'%(caster, userid, damage))
                    es.server.queuecmd('est_burn %s %s'%(userid, 6))
                else:
                    es.server.queuecmd('point_hurt %s %s %s'%(caster, userid, damage/2))
                    
def round_start(ev):
    global BOMB_PLANTED
    global HOSTAGE_GRABBED
    BOMB_PLANTED = 0
    HOSTAGE_GRABBED = 0
    gamethread.cancelDelayed('aoeregen')
        
def bomb_planted(ev):
    global BOMB_PLANTED
    BOMB_PLANTED = 1
    gold(ev['userid'], BOMB_GOLD, 'setting us up the bomb')
    
def bomb_defused(ev):
    gold(ev['userid'], DEFUSED_GOLD, 'cutting the correct wire')
    
def hostage_follows(ev):
    global HOSTAGE_GRABBED
    HOSTAGE_GRABBED = 1
    
def hostage_rescued(ev):
    gold(ev['userid'], HOSTAGE_GOLD, 'rescuing a hostage')
                
def player_spawn(ev):
    handle = es.getplayerhandle(ev['userid'])
    for weapon in weaponlib.getWeaponList('#primary'):
      for index in weapon.indexlist:
         if es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity') == handle:
            es.server.cmd('es_xremove %s'%index)
    for weapon in weaponlib.getWeaponList('#secondary'):
      for index in weapon.indexlist:
         if es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity') == handle:
            es.server.cmd('es_xremove %s'%index)

def gold(attacker=None, reward=0, reason=None):
    level = 0
    if not attacker:
        attacker = es.getargv(1)
        try:
            level = int(es.getargv(2))
        except:
            return
        newGold = max(1, (level -1 / 5)) * random.choice(KILL_GOLD) 
        es.tell(attacker, '#multi', '#green[D&D] #defaultYou have gained #green%s Gold #default for getting a kill!'%newGold)
    else:
        newGold = random.choice(reward)
        es.tell(attacker, '#multi', '#green[D&D] #defaultYou have gained #green%s Gold #default for %s!'%(newGold, reason)) 
    
    gold = 0
    try:
        gold = int(es.keygetvalue('dndUsers', es.getplayersteamid(attacker), 'gold'))
    except:
        gold = gold
    es.keysetvalue('dndUsers', es.getplayersteamid(attacker), 'gold', gold + newGold)
    
def zombieghoul():
    racechoice = popuplib.easymenu('undeadreschoice_%s'%es.getargv(1), None, necroresmenu)
    racechoice.settitle('Choose to raise your teamate as a zombie or a ghoul:')
    racechoice.addoption(1, 'Zombie')
    racechoice.addoption(2, 'Ghoul')
    es.server.queuecmd('mcudnd %s'%es.getargv(1))
    gamethread.delayed(.2, racechoice.send, es.getargv(1))
        
def necroresmenu(player, choice, popupname):
    race = ''
    if choice == 1:
        race = 'Zombie'
        es.keysetvalue('dndExtra', es.getplayersteamid(player), 'zresrace', race)
    if choice == 2:
        race = 'Ghoul'
        es.keysetvalue('dndExtra', es.getplayersteamid(player), 'zresrace', race)
    resmenu = popuplib.easymenu('necroresmenu_%s'%player, None, undeadchoice)
    resmenu.settitle('Choose a dead teamate to turn into a %s:'%race)
    for userid in es.getUseridList():
        if playerlib.getPlayer(userid).isdead and es.getplayerteam(player) == es.getplayerteam(userid) and es.getplayersteamid(userid) != 'BOT':
            resmenu.addoption(userid, es.getplayername(userid))
    es.server.queuecmd('mcudnd %s'%player)
    gamethread.delayed(.2, resmenu.send, player)
    
def undeadchoice(userid, choice, popupname):
    race = es.keygetvalue('dndExtra', es.getplayersteamid(userid), 'zresrace')
    playerchoice = popuplib.easymenu('reschoice_%s'%choice, None, undeadchoice2)
    playerchoice.settitle('Do you want to be resurrected into a %s?'%race)
    playerchoice.addoption(1, 'Yes')
    playerchoice.addoption(2, 'No')
    es.server.queuecmd('mcudnd %s'%choice)
    gamethread.delayed(.2, playerchoice.send, choice)
    es.keysetvalue('dndExtra', es.getplayersteamid(choice), 'zreser', userid)
    
def undeadchoice2(userid, choice, popupname):
    necro = es.keygetvalue('dndExtra', es.getplayersteamid(userid), 'zreser')
    racechoice = es.keygetvalue('dndExtra', es.getplayersteamid(necro), 'zresrace')
    race = es.keygetvalue('dndUsers', es.getplayersteamid(userid), 'race')
    if choice == 1:
        if not playerlib.getPlayer(necro).isdead:
            if playerlib.getPlayer(userid).isdead:
                if race in ['Zombie', 'Ghoul']:
                    es.tell(necro, '#multi', '#green[D&D] #default%s is undead and can not be rezzed'%es.getplayername(userid))
                else:
                    mana = int(es.keygetvalue('dndExtra', es.getplayersteamid(necro), 'mana'))
                    if mana >= 25:
                        es.keysetvalue('dndExtra', es.getplayersteamid(necro), 'mana', mana-25)
                        es.keysetvalue('dndExtra', es.getplayersteamid(userid), 'la', es.keygetvalue('dndUsers', es.getplayersteamid(userid), 'la'))
                        es.keysetvalue('dndExtra', es.getplayersteamid(userid), 'curxp', es.keygetvalue('dndUsers', es.getplayersteamid(userid), 'curxp'))
                        es.keysetvalue('dndExtra', es.getplayersteamid(userid), 'race', es.keygetvalue('dndUsers', es.getplayersteamid(userid), 'race'))
                        es.keysetvalue('dndExtra', es.getplayersteamid(userid), 'class', es.keygetvalue('dndUsers', es.getplayersteamid(userid), 'class'))
                        es.keysetvalue('dndExtra', es.getplayersteamid(userid), 'prestige', es.keygetvalue('dndUsers', es.getplayersteamid(userid), 'prestige'))
                        es.keysetvalue('dndExtra', es.getplayersteamid(userid), 'monster', es.keygetvalue('dndUsers', es.getplayersteamid(userid), 'monster'))
                        es.keysetvalue('dndExtra', es.getplayersteamid(userid), 'makersteam', es.getplayersteamid(necro))
                        es.keysetvalue('dndExtra', es.getplayersteamid(userid), 'makeruser', necro)
                        
                        es.keysetvalue('dndExtra', es.getplayersteamid(userid), 'zombie', 1)
                        es.keysetvalue('dndUsers', es.getplayersteamid(userid), 'race', racechoice)
                        es.keysetvalue('dndUsers', es.getplayersteamid(userid), 'monster', 1)
                        
                        x = es.keygetvalue('dndExtra', es.getplayersteamid(userid), 'd_x')
                        y = es.keygetvalue('dndExtra', es.getplayersteamid(userid), 'd_y')
                        z = es.keygetvalue('dndExtra', es.getplayersteamid(userid), 'd_z')
                        es.server.queuecmd('est_spawn %s'%userid)
                        es.server.queuecmd('ma_teleport %s %s %s %s'%(userid, x, y, z))
                        es.tell(userid, '#multi', '#green[D&D] #default%s has turned you into a %s!'%(es.getplayername(necro), racechoice))
                        es.tell(necro, '#multi', '#green[D&D] #defaultYou have raised %s as a %s to fight for you!'%(es.getplayername(userid), racechoice))
                    else:
                        es.tell(necro, '#multi', '#green[D&D] #defaultYou do not have enough mana to cast that spell!')
            else:
                es.tell(necro, '#multi', '#green[D&D] #default%s is already alive and can not be rezzed'%es.getplayername(userid))
    else:
        es.tell(necro, '#multi', '#green[D&D] #default%s doesn\'t want to be a %s'%(es.getplayername(userid), racechoice))
        
def rebukeaoe():
    caster = es.getargv(1)
    level = int(es.getargv(1))
    undead = playerlib.getPlayer(caster).getNearPlayers(600)
    for userid in undead:
        race = es.keygetvalue('dndUsers', es.getplayersteamid(userid), 'race')
        if not playerlib.getPlayer(userid).isdead and race in ['Zombie', 'Ghoul', 'Vampire']:
            if race in ['Zombie', 'Ghoul']:
                hits = 0
                try:
                    hits = int(es.keygetvalue('dndExtra', es.getplayersteamid(userid), 'hitcount'))
                except:
                    pass
                maxhits = int(es.keygetvalue('dndExtra', es.getplayersteamid(userid), 'maxhits'))
                maxhits += level
                hits -= level
                es.keysetvalue('dndExtra', es.getplayersteamid(userid), 'maxhits', maxhits)
                es.keysetvalue('dndExtra', es.getplayersteamid(userid), 'hitcount', hits)
                es.tell(caster, '#multi', '#green[D&D] #defaultYou rebuked an undead for %s extra hits!'%level)
                es.tell(userid, '#multi', '#green[D&D] #defaultYou were rebuked for %s extra hits!'%level)
            if race == 'Vampire':
                maxhealth = int(es.keygetvalue('dndExtra', es.getplayersteamd(userid), 'maxhealth'))
                maxhealth += level
                es.keysetvalue('dndExtra', es.getplayersteamd(userid), 'maxhealth', maxhealth)
                es.setplayerprop(userid, 'CBasePlayer.m_iHealth', int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth')) + level)
                es.tell(caster, '#multi', '#green[D&D] #defaultYou rebuked a Vampire for %s extra health!'%level)
                es.tell(userid, '#multi', '#green[D&D] #defaultYou were rebuked for %s extra health!'%level)
                
def pythonhurtundead():
    caster = es.getargv(1)    
    undead = playerlib.getPlayer(caster).getNearPlayers(600)
    for userid in undead:
        race = es.keygetvalue('dndUsers', es.getplayersteamid(userid), 'race')
        if not playerlib.getPlayer(userid).isdead and race in ['Zombie', 'Ghoul', 'Vampire', 'Alhoon']:
            if race in ['Zombie', 'Ghoul']:
                hits = 0
                try:
                    hits = int(es.keygetvalue('dndExtra', es.getplayersteamid(userid), 'hitcount'))
                except:
                    pass
                hits += level
                if race == 'Zombie':
                    if hits >= 35:
                         es.server.queuecmd('point_hurt %s %s 5000'%(caster, userid))
                if race == 'Ghoul':
                    if hits >= 17:
                         es.server.queuecmd('point_hurt %s %s 5000'%(caster, userid))
                if race == 'Alhoon':
                    es.server.cmd('bossturn %s %s'%(caster, level))
                es.keysetvalue('dndExtra', es.getplayersteamid(userid), 'hitcount', hits)
                es.tell(caster, '#multi', '#green[D&D] #defaultYou Turned an undead for %s hits!'%level)
                es.tell(userid, '#multi', '#green[D&D] #defaultYou were Turned for %s hits!'%level)
            if race == 'Vampire':
                es.keysetvalue('dndExtra', es.getplayersteamd(userid), 'maxhealth', maxhealth)
                es.setplayerprop(userid, 'CBasePlayer.m_iHealth', int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth')) - level)
                es.tell(caster, '#green', 'You Turned a Vampire for %s damage!'%level)
                es.tell(userid, '#green', 'You were Turned for %s damage!'%level)
                
def player_death(ev):
    if ev['weapon'] == 'knife':
        gold(ev['attacker'], KNIFE_GOLD, 'shanking %s'%ev['es_username'])
    if ev['weapon'] == 'hegrenade':
        gold(ev['attacker'], GRENADE_GOLD, 'exploding %s'%ev['es_username'])
    if es.keygetvalue('dndUsers', ev['es_steamid'], 'class') == 'Necromancer':
        for player in es.getUseridList():
            es.server.queuecmd('zombiekill %s %s'%(player, ev['userid']))
            
    check = 1
    for userid in es.getUseridList():
        if es.getplayersteamid(userid) != 'BOT':
            if not es.getplayerprop(userid, 'CBasePlayer.pl.deadflag'):
                check = 0
    if check:
        if not BOMB_PLANTED:
            if not HOSTAGE_GRABBED:
                es.server.cmd('ma_slay #bot')
                if es.getplayersteamid(userid) != 'BOT':
                    es.msg('#multi', '#green[D&D] #defaultBots have been slain to end the round')
                
def bardboost():
    caster = es.getargv(1)
    level = int(es.keygetvalue('dndUsers', es.getplayersteamid(caster), 'bard'))
    try:
        level -= int(es.keygetvalue('dndUsers', es.getplayersteamid(caster), 'la'))
    except:
        level = level
    bardTime = 10
    if level == 20:
        bardTime = 20
    allies = playerlib.getPlayer(caster).getNearPlayers(480)
    allies.append(caster)
    for userid in allies:
        if not es.getplayerprop(userid, "CBasePlayer.pl.deadflag") and es.getplayerteam(userid) == es.getplayerteam(caster):
            es.keysetvalue('dndExtra', es.getplayersteamid(userid), 'bard_dmg', 1)
            gamethread.delayed(bardTime, es.keysetvalue, ('dndExtra', es.getplayersteamid(userid), 'bard_dmg', 0))
            es.tell(userid, '#multi', '#green[D&D] #defaultA friendly Bard boosted your damage for the next %s seconds!'%bardTime)
            gamethread.delayed(bardTime, es.tell, (userid, '#multi', '#green[D&D] #defaultYour bonus damage from your Bard has ended'))
            
def bardcharge():
    caster = es.getargv(1)
    level = int(es.keygetvalue('dndUsers', es.getplayersteamid(caster), 'bard'))
    try:
        level -= int(es.keygetvalue('dndUsers', es.getplayersteamid(caster), 'la'))
    except:
        level = level
    bardTime = 4
    if level == 20:
        bardTime = 8
    allies = playerlib.getPlayer(caster).getNearPlayers(480)
    allies.append(caster)
    for userid in allies:
        if not playerlib.getPlayer(userid).isdead and es.getplayerteam(userid) == es.getplayerteam(caster):            
            speed = float(es.keygetvalue('dndExtra', es.getplayersteamid(userid), 'speed'))
            es.keysetvalue('dndExtra', es.getplayersteamid(userid), 'speed', speed+.25)
            es.server.cmd('est_speed %s %s'%(userid, speed+.25))            
            es.tell(userid, '#multi', '#green[D&D] #defaultA friendly Bard boosted your speed for the next %s seconds!'%bardTime)
            gamethread.delayed(bardTime, removespeed, args=(userid, speed, bardTime))
            
def removespeed(userid, speed, bardTime):
    es.server.cmd('est_speed %s %s'%(userid, speed))
    es.tell(userid, '#multi', '#green[D&D] #defaultYour bonus speed from your Bard has ended')
    es.keysetvalue('dndExtra', es.getplayersteamid(userid), 'speed', speed)
            
            
def bardgrav(caster=None):
    if not caster:
        caster = es.getargv(1)
    enemies = playerlib.getPlayer(caster).getNearPlayers(2000)
    for enemy in enemies:
        if es.getplayerteam(enemy) != es.getplayerteam(caster) and not playerlib.getPlayer(caster).isdead:
            es.server.queuecmd('est_gravity %s 1.00'%enemy)
            gamethread.delayed(4, bardgrav, caster)
            
def bardshock():
    caster = es.getargv(1)
    level = int(es.keygetvalue('dndUsers', es.getplayersteamid(caster), 'bard'))
    try:
        level -= int(es.keygetvalue('dndUsers', es.getplayersteamid(caster), 'la'))
    except:
        level = level
    
    bardTime = [1,2,3]
    if level == 20:
        bardTime = [1,2,3,4,5,6]
    damage = level
    if level > 10:
        damage = 10
    
    es.tell(caster, '#multi', '#green[D&D] #defaultYour song of stunning is active for the next %s seconds!'%bardTime[-1])
    gamethread.delayed(bardTime[-1], es.tell, ('#green', 'Your song of stunning has ended'))
    
    for x in bardTime:
        gamethread.delayed(x, shockLoop, args=(caster, damage))
        
def shockLoop(caster, damage):
    allies = playerlib.getPlayer(caster).getNearPlayers(480)
    allies.append(caster)
    for userid in allies:
        if not playerlib.getPlayer(userid).isdead and es.getplayerteam(userid) != es.getplayerteam(caster):
            save = random.randint(1,20)
            if save != 20:
                try:
                    save += int(float(es.keygetvalue('dndExtra', es.getplayersteamid(userid), 'fortsave')))
                except:
                    save = save
                if save > 16:
                    damage = damage / 2
                else:
                    es.server.queuecmd('est_freeze %s 1'%userid)
                    try:
                        int(es.keygetvalue('dndExtra', es.getplayersteamid(userid), 'death_attack'))
                    except:
                        gamethread.delayed(.9, es.server.queuecmd, args=('est_freeze %s 0'%userid))
                es.server.queuecmd('point_hurt %s %s %s'%(caster, userid, damage))
                
def pythonmeteor(caster=None, level=None, loop=None):
    if not caster:
        caster = es.getargv(1)
        level = int(es.getargv(2))
        loop = 5
    if not playerlib.getPlayer(caster).isdead:
        damage = random.randint(1,4) * max(1,int(random.randint(1,level)/2))
        enemies = playerlib.getPlayer(caster).getNearPlayers(1000)
        for enemy in enemies:
            if es.getplayerteam(enemy) != es.getplayerteam(caster) and not playerlib.getPlayer(caster).isdead:
                save = random.randint(1,20)
                if save != 20:
                    try:
                        save += int(float(es.keygetvalue('dndExtra', es.getplayersteamid(enemy), 'reflexsave')))
                    except:
                        save = save
                    save -= random.choice(3,4)
                    if es.keygetvalue('dndUsers', es.getplayersteamid(enemy), 'race') == 'troll':
                        damage = damage * 2
                    if save > 14:
                        damage = damage / 2
                    else:
                        es.server.queuecmd('est_burn %s 4'%enemy)
                    es.server.queuecmd('point_hurt %s %s %s'%(caster, enemy, damage))
        loop -= 1
        if loop:
            gamethread.delayed(1, pythonmeteor, args=(caster, level, loop))
            
def teamheal():
    userid = es.getargv(1)
    for player in es.getUseridList():
        if es.getplayerteam(player) == es.getplayerteam(userid):
            if not es.getplayerprop(player, 'CBasePlayer.pl.deadflag'):
                playerlib.getPlayer(player).add('health', 15)
                es.tell(player, '#multi', '#green[D&D] #defaultA Cleric has given you life!')